
### Constructor functions for various parameters in MLP
# to be used with SelectedModel to choose best model



## MLP model extension
MLPModelSize1Max1Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=20, learnParam = 0.05, ...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize1Max1Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=20, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize1Max1Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=20, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)


## MLP model extension
MLPModelSize1Max2Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=50, learnParam = 0.05,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize1Max2Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=50, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize1Max2Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=50, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize1Max3Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=100, learnParam = 0.05,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize1Max3Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=100, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize1Max3Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 50), maxit=100, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize2Max1Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=20, learnParam = 0.05, ...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize2Max1Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=20, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize2Max1Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=20, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)


## MLP model extension
MLPModelSize2Max2Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=50, learnParam = 0.05,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize2Max2Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=50, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize2Max2Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=50, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize2Max3Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=100, learnParam = 0.05,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize2Max3Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=100, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize2Max3Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50), maxit=100, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize3Max1Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=20, learnParam = 0.05, ...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize3Max1Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=20, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize3Max1Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=20, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)


## MLP model extension
MLPModelSize3Max2Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=50, learnParam = 0.05,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize3Max2Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=50, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize3Max2Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=50, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

## MLP model extension
MLPModelSize3Max3Learn1 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=100, learnParam = 0.05,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize3Max3Learn2 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=100, learnParam = 0.1,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

MLPModelSize3Max3Learn3 <- MLModel(
  name = "MLPModel",
  label = "MLP Model",
  response_types = "binary",
  packages = "RSNNS", 
  fit = function(formula, data, ...) {
    
    mm <- model.matrix(formula, as.data.frame(data))
    valuesDat <- mm[,-1]
    targetDat <- RSNNS::decodeClassLabels(as.data.frame(data)[,all.vars(formula)[1]])
    
    RSNNS::mlp(valuesDat, targetDat, size = c(50, 100, 50, 100), maxit=100, learnParam = 0.4,...)
    
  },
  predict = function(object, newdata, ...) {
    predict(object, newdata = as.data.frame(newdata), type = 'response')
  }
)

sel_model <- SelectedModel(MLPModelSize1Max1Learn1,
                           MLPModelSize1Max1Learn2,
                           MLPModelSize1Max1Learn3,
                           MLPModelSize1Max2Learn1,
                           MLPModelSize1Max2Learn2,
                           MLPModelSize1Max2Learn3,
                           MLPModelSize1Max3Learn1,
                           MLPModelSize1Max3Learn2,
                           MLPModelSize1Max3Learn3,
                           MLPModelSize2Max1Learn1,
                           MLPModelSize2Max1Learn2,
                           MLPModelSize2Max1Learn3,
                           MLPModelSize2Max2Learn1,
                           MLPModelSize2Max2Learn2,
                           MLPModelSize2Max2Learn3,
                           MLPModelSize2Max3Learn1,
                           MLPModelSize2Max3Learn2,
                           MLPModelSize2Max3Learn3,
                           MLPModelSize3Max1Learn1,
                           MLPModelSize3Max1Learn2,
                           MLPModelSize3Max1Learn3,
                           MLPModelSize3Max2Learn1,
                           MLPModelSize3Max2Learn2,
                           MLPModelSize3Max2Learn3,
                           MLPModelSize3Max3Learn1,
                           MLPModelSize3Max3Learn2,
                           MLPModelSize3Max3Learn3)





























