
################################################################################
# Corresponding final models for:
# Radiomics Detection of Pulmonary Hypertension via Texture-based Assessments 
#   of Cardiac MRI: A Machine-learning Model Comparison
################################################################################

library(MachineShop)


eslv_fit <- readRDS('mlp_full_fit_entire.rds')
eslv_sub_fit <- readRDS('mlp_full_fit_subgroup.rds')

### Observed performance function
obsAUC <- function(fits) {
  obs <- response(fits)
  pred <- predict(fits, type = 'prob')
  performance(obs, pred)
}

# observed performance metrics (based on final fit to full data)
obsAUC(eslv_fit) 
obsAUC(eslv_sub_fit) 

# to predict on a new data set:
# data must have the same column names as are used in this file
newDat <- read.csv('fakeNewData.csv')
newDat$Outcome <- factor(newDat$Outcome)

# data was not generated to have any differences between groups.
#   We do not expect the model to perform well on this fake data!
obs <- newDat$Outcome
pred <- predict(eslv_fit, type = 'prob', newdata = newDat)
performance(obs, pred)



